Module modChannel

    Public sCh(1920) As String

    Public Sub LoadChannel()
        Try
            Dim oIniCh As cIni

            oIniCh = New cIni(GetAppPath() & "\ch.ini")
            oIniCh.Section = "TSID"
            Dim sText() As String = oIniCh.GetKeys()

            If sText Is Nothing Then Exit Sub

            Dim sKey() As String
            Dim I As Integer
            Dim nCnt As Integer = UBound(sText)

            For I = 0 To nCnt
                sKey = Split(sText(I), "=")
                sCh(&H8000 - Convert.ToInt32(sKey(0), 16)) = sKey(1)
            Next
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

    End Sub

    Public Function CombCh(ByVal s As String, ByVal sCh As String, Optional ByVal sSep As String = "") As String
        Dim s As String

        Select Case s
            Case "TB", "BS", "CS1", "CS2"
                s = Left(s, 2) & sCh
            Case Else
                s = s & IIf(Trim(s) = "" OrElse Trim(sCh) = "", "", sSep) & sCh
        End Select

        Return s
    End Function

    Public Function GetChFromSID(ByVal SID As Integer) As String
        Dim TSID As Integer

        TSID = (&H7FF - Int(SID / &H400)) * &H10 + ((SID Mod &H100) / &H8) Mod &H10

        Dim s As String = sCh(&H8000 - TSID)

        If Val(s) > 0 Then
            Dim n3, n2, n1 As Integer

            n3 = Int((SID Mod &H400) / &H80) * 2
            n2 = Val(s)
            n1 = (SID Mod &H8) + 1
            s = Format(n3 * 100 + n2 * 10 + n1, "000")
        Else
            s = ""
        End If

        Return s
    End Function
End Module
